<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="p-4 h-100 bg-light">

  <app-breadcrumbs></app-breadcrumbs>

  <div
    class="h4 mt-4 fw-bold"
    [innerText]="messages.PAGE_TITLE">
  </div>

  <div
    class="h5 text-muted"
    [innerText]="messages.SELECT_A_DESK_MESSAGE">
  </div>

  <div class="text-dark h5 d-flex">
    {{ messages.getThumbsOrFavoritesTitle(userPreferences?.favoriteDesks.length) }}
    <app-toggle-button
      [disableTooltip]="!disableDisplayMode"
      [ngbTooltip]="messages.DISABLED_DISPLAY_MODE_TOOLTIP"
      class="mx-2"
      [disabled]="disableDisplayMode"
      [boolean]="displayMode === DISPLAY_MODE_ENUM.LIST"
      (valueChange)="changeDisplayMode()">
    </app-toggle-button>
    <span
      id="displayModeListLabel"
      [innerText]="messages.DISPLAY_MODE_LIST">
    </span>
  </div>

  <div class="select-desks-top-line mb-4">

    <app-search-bar
      class="search-input"
      (debouncedKeyup)="updateSearchTerm($event)"
      [placeholder]="commonMessages.SEARCH_DESK">
    </app-search-bar>

    <div class="horizontal-spacer"></div>

    <div *ngIf="displayMode === DISPLAY_MODE_ENUM.LIST" class="pagination-block">
      <label
        class="display-mode-text"
        [innerText]="commonMessages.PAGINATION_SIZE_LABEL">
      </label>
      <ngb-pagination
        class="mb-2"
        size="sm"
        [collectionSize]="pageSizes.length"
        [(page)]="pageSizeIndex"
        [pageSize]="1"
        [rotate]="false"
        [boundaryLinks]="false"
        [directionLinks]="false"
        (pageChange)="updatePage()">
        <ng-template ngbPaginationNumber let-p>{{ getPageSize(p) }}</ng-template>
      </ngb-pagination>
    </div>
  </div>

  <div
    *ngIf="displayMode===DISPLAY_MODE_ENUM.LIST"
    class="d-flex flex-column flex-nowrap justify-content-center">

    <table
      aria-labelledby="displayModeListLabel"
      class="bg-white table table-striped table-borderless border shadow-sm table-text-overflow w-100">
      <thead class="border">
        <tr>
          <th scope="col" class="th-sm pointer" (click)="sort()">
            <fa-icon
              [fixedWidth]="true"
              [icon]="asc ? caretUp : caretDown">
            </fa-icon>
            {{ commonMessages.NAME }}
          </th>
          <th
            scope="col"
            class="th-sm col-buttons-fixed-size col-buttons-5-buttons"
            [innerText]="commonMessages.FOLDER_TRAY">
          </th>
        </tr>
      </thead>
      <tbody>
        <ng-container *ngFor="let elem of flattenTreeStructure">
          <tr *ngIf="elem.expanded || !elem.isDesk">
            <td
              class="overflow-hidden text-overflow-ellipsis pointer"
              (click)="elem.isDesk ? navigateToDesk(elem) : expandOrCollapse(elem)">
              <fa-icon
                class="invisible left-padding"
                *ngIf="elem.isDesk"
                [fixedWidth]="true"
                [icon]="caretUp">
              </fa-icon>
              <fa-icon
                *ngIf="!elem.isDesk"
                [icon]="elem.expanded ? caretDownIcon : caretRightIcon"
                [ngbTooltip]="elem.expanded ? commonMessages.FOLD : commonMessages.EXPAND"
                [fixedWidth]="true"
                class="pointer">
              </fa-icon>
              {{ elem.isDesk ? elem.deskWithCount?.desk.name : elem.tenant.name | namePipe }}
            </td>

            <ng-container *ngIf="elem.isDesk && elem.deskWithCount as deskWithCount">
              <td class="align-self-end folder-count-badges pointer-badge-container">
                <span
                  *ngIf="deskWithCount.count?.lateFoldersCount > 0"
                  class="badge badge-late mx-1"
                  routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}"
                  [ngbTooltip]="stateEnum.Late | stateName"
                  openDelay="300"
                  [innerText]="deskWithCount.count?.lateFoldersCount">
                </span>
                <span
                  *ngIf="deskWithCount.count?.finishedFoldersCount > 0"
                  class="badge badge-finished mx-1"
                  routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}/finished"
                  [ngbTooltip]="stateEnum.Finished | stateName"
                  openDelay="300"
                  [innerText]="deskWithCount.count?.finishedFoldersCount">
                </span>
                <span
                  *ngIf="deskWithCount.count?.rejectedFoldersCount > 0"
                  class="badge badge-rejected mx-1"
                  routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}/rejected"
                  [ngbTooltip]="stateEnum.Rejected | stateName"
                  openDelay="300"
                  [innerText]="deskWithCount.count?.rejectedFoldersCount">
                </span>
                <span
                  *ngIf="deskWithCount.count?.draftFoldersCount > 0"
                  class="badge badge-draft mx-1"
                  routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}/draft"
                  [ngbTooltip]="stateEnum.Draft | stateName"
                  openDelay="300"
                  [innerText]="deskWithCount.count?.draftFoldersCount">
                </span>
                <span
                  class="badge badge-pending mx-1"
                  routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}"
                  [ngbTooltip]="stateEnum.Current | stateName"
                  openDelay="300"
                  [innerText]="deskWithCount.count?.pendingFoldersCount">
                </span>
                <span
                  *ngIf="computeDelegatedTotalFn(deskWithCount.count) > 0"
                  class="badge badge-delegated mx-1"
                  routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}/delegated"
                  [ngbTooltip]="stateEnum.Delegated | stateName"
                  openDelay="300"
                  [innerText]="computeDelegatedTotalFn(deskWithCount.count)">
                </span>
              </td>
            </ng-container>

            <td *ngIf="!elem.isDesk"></td>
          </tr>
        </ng-container>
      </tbody>
      <tbody
        app-list-loader
        [data]="desks"
        [loading]="loading"
        [colspan]="colspan"
        [emptyMessage]="commonMessages.EMPTY_DESK_LIST">
      </tbody>
    </table>

    <ngb-pagination
      class="d-flex justify-content-end"
      size="sm"
      [collectionSize]="computeTotal()"
      [pageSize]="pageSize"
      [(page)]="page"
      [maxSize]="5"
      [rotate]="true"
      [boundaryLinks]="false"
      [directionLinks]="false"
      (pageChange)="updatePage()">
    </ngb-pagination>
  </div>

  <ng-container *ngIf="!!chunkDesks && displayMode === DISPLAY_MODE_ENUM.THUMBS">
    <div
      class="d-flex flex-row flex-nowrap justify-content-center"
      *ngFor="let deskChunk of chunkDesks">
      <div
        *ngFor="let deskWithCount of deskChunk"
        [state]="{filterId: userPreferences.currentFilter?.id}"
        routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}/{{ getDefaultFilterRoutePath() }}"
        class="p-2 pointer">
        <div class="d-flex flex-column justify-content-center border shadow-sm bg-white desk-layout">
          <div class="mt-3 m-2 d-flex justify-content-center folder-count-badges pointer-badge-container">
            <ng-container *ngIf="deskWithCount.count">
              <div appClickStopPropagation>
                <span
                  *ngIf="deskWithCount.count?.lateFoldersCount > 0"
                  [innerText]="deskWithCount.count?.lateFoldersCount"
                  [ngbTooltip]="stateEnum.Late | stateName"
                  class="badge badge-late mx-1"
                  openDelay="300"
                  routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}/late">
                </span>
                <span
                  *ngIf="deskWithCount.count?.finishedFoldersCount > 0"
                  [innerText]="deskWithCount.count?.finishedFoldersCount"
                  [ngbTooltip]="stateEnum.Finished | stateName"
                  class="badge badge-finished mx-1"
                  openDelay="300"
                  routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}/finished">
                </span>
                <span
                  *ngIf="deskWithCount.count?.rejectedFoldersCount > 0"
                  [innerText]="deskWithCount.count?.rejectedFoldersCount"
                  [ngbTooltip]="stateEnum.Rejected | stateName"
                  class="badge badge-rejected mx-1"
                  openDelay="300"
                  routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}/rejected">
                </span>
                <span
                  *ngIf="deskWithCount.count?.draftFoldersCount > 0"
                  [innerText]="deskWithCount.count?.draftFoldersCount"
                  [ngbTooltip]="stateEnum.Draft | stateName"
                  class="badge badge-draft mx-1"
                  openDelay="300"
                  routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}/draft">
                </span>
                <span
                  [innerText]="deskWithCount.count?.pendingFoldersCount || 0"
                  [ngbTooltip]="stateEnum.Current | stateName"
                  class="badge badge-pending mx-1"
                  openDelay="300"
                  routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}">
                </span>
                <span
                  *ngIf="deskWithCount.count && computeDelegatedTotalFn(deskWithCount.count) > 0"
                  [innerText]="computeDelegatedTotalFn(deskWithCount.count)"
                  class="badge badge-delegated mx-1"
                  [ngbTooltip]="stateEnum.Delegated | stateName"
                  openDelay="300"
                  routerLink="/tenant/{{ deskWithCount.desk?.tenantId }}/desk/{{ deskWithCount.desk?.id }}/delegated">
                </span>
              </div>
            </ng-container>
          </div>

          <fa-icon
            class="fa-3x text-center"
            [icon]="deskIcon">
          </fa-icon>

          <a
            class="w-100 align-self-center text-center px-2 desk-text-container text-dark"
            [ngbTooltip]="deskWithCount.desk?.name | namePipe"
            [openDelay]="300"
            [innerText]="deskWithCount.desk?.name | namePipe">
          </a>

        </div>
      </div>
    </div>
    <div
      *ngIf="!!chunkDesks && chunkDesks.length === 0 && currentSearchTerm == null"
      class="text-secondary text-center"
      [innerHTML]="messages.NO_DESK_ASSIGNED_MESSAGE">
    </div>
    <div
      *ngIf="!!chunkDesks && chunkDesks.length === 0 && currentSearchTerm != null"
      class="text-secondary text-center"
      [innerHTML]="messages.NO_DESK_FILTER_MESSAGE">
    </div>
  </ng-container>
</div>
